Index: code/branches/physics/src/bullet/BulletCollision/BroadphaseCollision/btDbvt.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/BroadphaseCollision/btDbvt.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/BroadphaseCollision/btDbvt.h	(revision 2430)
@@ -715,59 +723,277 @@
 DBVT_PREFIX
 inline void		btDbvt::collideTT(	const btDbvtNode* root0,
-									const btDbvtNode* root1,
-									DBVT_IPOLICY)
-{
-DBVT_CHECKTYPE
-if(root0&&root1)
-	{
-	btAlignedObjectArray<sStkNN>	stack;
-	int								depth=1;
-	int								treshold=DOUBLE_STACKSIZE-4;
-	stack.resize(DOUBLE_STACKSIZE);
-	stack[0]=sStkNN(root0,root1);
-	do	{		
-		sStkNN	p=stack[--depth];
-		if(depth>treshold)
+								  const btDbvtNode* root1,
+								  DBVT_IPOLICY)
+{
+	DBVT_CHECKTYPE
+		if(root0&&root1)
+		{
+			int								depth=1;
+			int								treshold=DOUBLE_STACKSIZE-4;
+			btAlignedObjectArray<sStkNN>	stkStack;
+			stkStack.resize(DOUBLE_STACKSIZE);
+			stkStack[0]=sStkNN(root0,root1);
+			do	{		
+				sStkNN	p=stkStack[--depth];
+				if(depth>treshold)
+				{
+					stkStack.resize(stkStack.size()*2);
+					treshold=stkStack.size()-4;
+				}
+				if(p.a==p.b)
+				{
+					if(p.a->isinternal())
+					{
+						stkStack[depth++]=sStkNN(p.a->childs[0],p.a->childs[0]);
+						stkStack[depth++]=sStkNN(p.a->childs[1],p.a->childs[1]);
+						stkStack[depth++]=sStkNN(p.a->childs[0],p.a->childs[1]);
+					}
+				}
+				else if(Intersect(p.a->volume,p.b->volume))
+				{
+					if(p.a->isinternal())
+					{
+						if(p.b->isinternal())
+						{
+							stkStack[depth++]=sStkNN(p.a->childs[0],p.b->childs[0]);
+							stkStack[depth++]=sStkNN(p.a->childs[1],p.b->childs[0]);
+							stkStack[depth++]=sStkNN(p.a->childs[0],p.b->childs[1]);
+							stkStack[depth++]=sStkNN(p.a->childs[1],p.b->childs[1]);
+						}
+						else
+						{
+							stkStack[depth++]=sStkNN(p.a->childs[0],p.b);
+							stkStack[depth++]=sStkNN(p.a->childs[1],p.b);
+						}
+					}
+					else
+					{
+						if(p.b->isinternal())
+						{
+							stkStack[depth++]=sStkNN(p.a,p.b->childs[0]);
+							stkStack[depth++]=sStkNN(p.a,p.b->childs[1]);
+						}
+						else
+						{
+							policy.Process(p.a,p.b);
+						}
+					}
+				}
+			} while(depth);
+		}
+}
+
+
+
+DBVT_PREFIX
+inline void		btDbvt::collideTTpersistentStack(	const btDbvtNode* root0,
+								  const btDbvtNode* root1,
+								  DBVT_IPOLICY)
+{
+	DBVT_CHECKTYPE
+		if(root0&&root1)
+		{
+			int								depth=1;
+			int								treshold=DOUBLE_STACKSIZE-4;
+			
+			m_stkStack.resize(DOUBLE_STACKSIZE);
+			m_stkStack[0]=sStkNN(root0,root1);
+			do	{		
+				sStkNN	p=m_stkStack[--depth];
+				if(depth>treshold)
+				{
+					m_stkStack.resize(m_stkStack.size()*2);
+					treshold=m_stkStack.size()-4;
+				}
+				if(p.a==p.b)
+				{
+					if(p.a->isinternal())
+					{
+						m_stkStack[depth++]=sStkNN(p.a->childs[0],p.a->childs[0]);
+						m_stkStack[depth++]=sStkNN(p.a->childs[1],p.a->childs[1]);
+						m_stkStack[depth++]=sStkNN(p.a->childs[0],p.a->childs[1]);
+					}
+				}
+				else if(Intersect(p.a->volume,p.b->volume))
+				{
+					if(p.a->isinternal())
+					{
+						if(p.b->isinternal())
+						{
+							m_stkStack[depth++]=sStkNN(p.a->childs[0],p.b->childs[0]);
+							m_stkStack[depth++]=sStkNN(p.a->childs[1],p.b->childs[0]);
+							m_stkStack[depth++]=sStkNN(p.a->childs[0],p.b->childs[1]);
+							m_stkStack[depth++]=sStkNN(p.a->childs[1],p.b->childs[1]);
+						}
+						else
+						{
+							m_stkStack[depth++]=sStkNN(p.a->childs[0],p.b);
+							m_stkStack[depth++]=sStkNN(p.a->childs[1],p.b);
+						}
+					}
+					else
+					{
+						if(p.b->isinternal())
+						{
+							m_stkStack[depth++]=sStkNN(p.a,p.b->childs[0]);
+							m_stkStack[depth++]=sStkNN(p.a,p.b->childs[1]);
+						}
+						else
+						{
+							policy.Process(p.a,p.b);
+						}
+					}
+				}
+			} while(depth);
+		}
+}
+
+
+//
+DBVT_PREFIX
+inline void		btDbvt::collideTT(	const btDbvtNode* root0,
+								  const btDbvtNode* root1,
+								  const btTransform& xform,
+								  DBVT_IPOLICY)
+{
+	DBVT_CHECKTYPE
+		if(root0&&root1)
+		{
+			int								depth=1;
+			int								treshold=DOUBLE_STACKSIZE-4;
+			btAlignedObjectArray<sStkNN>	stkStack;
+			stkStack.resize(DOUBLE_STACKSIZE);
+			stkStack[0]=sStkNN(root0,root1);
+			do	{
+				sStkNN	p=stkStack[--depth];
+				if(Intersect(p.a->volume,p.b->volume,xform))
+				{
+					if(depth>treshold)
+					{
+						stkStack.resize(stkStack.size()*2);
+						treshold=stkStack.size()-4;
+					}
+					if(p.a->isinternal())
+					{
+						if(p.b->isinternal())
+						{					
+							stkStack[depth++]=sStkNN(p.a->childs[0],p.b->childs[0]);
+							stkStack[depth++]=sStkNN(p.a->childs[1],p.b->childs[0]);
+							stkStack[depth++]=sStkNN(p.a->childs[0],p.b->childs[1]);
+							stkStack[depth++]=sStkNN(p.a->childs[1],p.b->childs[1]);
+						}
+						else
+						{
+							stkStack[depth++]=sStkNN(p.a->childs[0],p.b);
+							stkStack[depth++]=sStkNN(p.a->childs[1],p.b);
+						}
+					}
+					else
+					{
+						if(p.b->isinternal())
+						{
+							stkStack[depth++]=sStkNN(p.a,p.b->childs[0]);
+							stkStack[depth++]=sStkNN(p.a,p.b->childs[1]);
+						}
+						else
+						{
+							policy.Process(p.a,p.b);
+						}
+					}
+				}
+			} while(depth);
+		}
+}
+
+//
+DBVT_PREFIX
+inline void		btDbvt::collideTT(	const btDbvtNode* root0,
+								  const btTransform& xform0,
+								  const btDbvtNode* root1,
+								  const btTransform& xform1,
+								  DBVT_IPOLICY)
+{
+	const btTransform	xform=xform0.inverse()*xform1;
+	collideTT(root0,root1,xform,policy);
+}
+
+//
+DBVT_PREFIX
+inline void		btDbvt::collideTV(	const btDbvtNode* root,
+								  const btDbvtVolume& vol,
+								  DBVT_IPOLICY)
+{
+	DBVT_CHECKTYPE
+		if(root)
+		{
+			ATTRIBUTE_ALIGNED16(btDbvtVolume)		volume(vol);
+			btAlignedObjectArray<const btDbvtNode*>	stack;
+			stack.resize(0);
+			stack.reserve(SIMPLE_STACKSIZE);
+			stack.push_back(root);
+			do	{
+				const btDbvtNode*	n=stack[stack.size()-1];
+				stack.pop_back();
+				if(Intersect(n->volume,volume))
+				{
+					if(n->isinternal())
+					{
+						stack.push_back(n->childs[0]);
+						stack.push_back(n->childs[1]);
+					}
+					else
+					{
+						policy.Process(n);
+					}
+				}
+			} while(stack.size()>0);
+		}
+}
+
+DBVT_PREFIX
+inline void		btDbvt::rayTestInternal(	const btDbvtNode* root,
+								const btVector3& rayFrom,
+								const btVector3& rayTo,
+								const btVector3& rayDirectionInverse,
+								unsigned int signs[3],
+								btScalar lambda_max,
+								const btVector3& aabbMin,
+								const btVector3& aabbMax,
+								DBVT_IPOLICY) const
+{
+	DBVT_CHECKTYPE
+	if(root)
+	{
+		btVector3 resultNormal;
+
+		int								depth=1;
+		int								treshold=DOUBLE_STACKSIZE-2;
+		btAlignedObjectArray<const btDbvtNode*>	stack;
+		stack.resize(DOUBLE_STACKSIZE);
+		stack[0]=root;
+		btVector3 bounds[2];
+		do	
+		{
+			const btDbvtNode*	node=stack[--depth];
+			bounds[0] = node->volume.Mins()+aabbMin;
+			bounds[1] = node->volume.Maxs()+aabbMax;
+			btScalar tmin=1.f,lambda_min=0.f;
+			unsigned int result1=false;
+			result1 = btRayAabb2(rayFrom,rayDirectionInverse,signs,bounds,tmin,lambda_min,lambda_max);
+			if(result1)
 			{
-			stack.resize(stack.size()*2);
-			treshold=stack.size()-4;
-			}
-		if(p.a==p.b)
-			{
-			if(p.a->isinternal())
-				{
-				stack[depth++]=sStkNN(p.a->childs[0],p.a->childs[0]);
-				stack[depth++]=sStkNN(p.a->childs[1],p.a->childs[1]);
-				stack[depth++]=sStkNN(p.a->childs[0],p.a->childs[1]);
-				}
-			}
-		else if(Intersect(p.a->volume,p.b->volume))
-			{
-			if(p.a->isinternal())
-				{
-				if(p.b->isinternal())
-					{
-					stack[depth++]=sStkNN(p.a->childs[0],p.b->childs[0]);
-					stack[depth++]=sStkNN(p.a->childs[1],p.b->childs[0]);
-					stack[depth++]=sStkNN(p.a->childs[0],p.b->childs[1]);
-					stack[depth++]=sStkNN(p.a->childs[1],p.b->childs[1]);
-					}
-					else
-					{
-					stack[depth++]=sStkNN(p.a->childs[0],p.b);
-					stack[depth++]=sStkNN(p.a->childs[1],p.b);
-					}
+				if(node->isinternal())
+				{
+					if(depth>treshold)
+					{
+						stack.resize(stack.size()*2);
+						treshold=stack.size()-2;
+					}
+					stack[depth++]=node->childs[0];
+					stack[depth++]=node->childs[1];
 				}
 				else
 				{
-				if(p.b->isinternal())
-					{
-					stack[depth++]=sStkNN(p.a,p.b->childs[0]);
-					stack[depth++]=sStkNN(p.a,p.b->childs[1]);
-					}
-					else
-					{
-					policy.Process(p.a,p.b);
-					}
+					policy.Process(node);
 				}
 			}
@@ -778,139 +1004,69 @@
 //
 DBVT_PREFIX
-inline void		btDbvt::collideTT(	const btDbvtNode* root0,
-									const btDbvtNode* root1,
-									const btTransform& xform,
-									DBVT_IPOLICY)
-{
-DBVT_CHECKTYPE
-if(root0&&root1)
-	{
-	btAlignedObjectArray<sStkNN>	stack;
-	int								depth=1;
-	int								treshold=DOUBLE_STACKSIZE-4;
-	stack.resize(DOUBLE_STACKSIZE);
-	stack[0]=sStkNN(root0,root1);
-	do	{
-		sStkNN	p=stack[--depth];
-		if(Intersect(p.a->volume,p.b->volume,xform))
-			{
-			if(depth>treshold)
-				{
-				stack.resize(stack.size()*2);
-				treshold=stack.size()-4;
-				}
-			if(p.a->isinternal())
-				{
-				if(p.b->isinternal())
-					{					
-					stack[depth++]=sStkNN(p.a->childs[0],p.b->childs[0]);
-					stack[depth++]=sStkNN(p.a->childs[1],p.b->childs[0]);
-					stack[depth++]=sStkNN(p.a->childs[0],p.b->childs[1]);
-					stack[depth++]=sStkNN(p.a->childs[1],p.b->childs[1]);
+inline void		btDbvt::rayTest(	const btDbvtNode* root,
+								const btVector3& rayFrom,
+								const btVector3& rayTo,
+								DBVT_IPOLICY)
+{
+	DBVT_CHECKTYPE
+		if(root)
+		{
+			btVector3 rayDir = (rayTo-rayFrom);
+			rayDir.normalize ();
+
+			///what about division by zero? --> just set rayDirection[i] to INF/1e30
+			btVector3 rayDirectionInverse;
+			rayDirectionInverse[0] = rayDir[0] == btScalar(0.0) ? btScalar(1e30) : btScalar(1.0) / rayDir[0];
+			rayDirectionInverse[1] = rayDir[1] == btScalar(0.0) ? btScalar(1e30) : btScalar(1.0) / rayDir[1];
+			rayDirectionInverse[2] = rayDir[2] == btScalar(0.0) ? btScalar(1e30) : btScalar(1.0) / rayDir[2];
+			unsigned int signs[3] = { rayDirectionInverse[0] < 0.0, rayDirectionInverse[1] < 0.0, rayDirectionInverse[2] < 0.0};
+
+			btScalar lambda_max = rayDir.dot(rayTo-rayFrom);
+
+			btVector3 resultNormal;
+
+			btAlignedObjectArray<const btDbvtNode*>	stack;
+
+			int								depth=1;
+			int								treshold=DOUBLE_STACKSIZE-2;
+
+			stack.resize(DOUBLE_STACKSIZE);
+			stack[0]=root;
+			btVector3 bounds[2];
+			do	{
+				const btDbvtNode*	node=stack[--depth];
+
+				bounds[0] = node->volume.Mins();
+				bounds[1] = node->volume.Maxs();
+				
+				btScalar tmin=1.f,lambda_min=0.f;
+				unsigned int result1 = btRayAabb2(rayFrom,rayDirectionInverse,signs,bounds,tmin,lambda_min,lambda_max);
+
+#ifdef COMPARE_BTRAY_AABB2
+				btScalar param=1.f;
+				bool result2 = btRayAabb(rayFrom,rayTo,node->volume.Mins(),node->volume.Maxs(),param,resultNormal);
+				btAssert(result1 == result2);
+#endif //TEST_BTRAY_AABB2
+
+				if(result1)
+				{
+					if(node->isinternal())
+					{
+						if(depth>treshold)
+						{
+							stack.resize(stack.size()*2);
+							treshold=stack.size()-2;
+						}
+						stack[depth++]=node->childs[0];
+						stack[depth++]=node->childs[1];
 					}
 					else
 					{
-					stack[depth++]=sStkNN(p.a->childs[0],p.b);
-					stack[depth++]=sStkNN(p.a->childs[1],p.b);
-					}
-				}
-				else
-				{
-				if(p.b->isinternal())
-					{
-					stack[depth++]=sStkNN(p.a,p.b->childs[0]);
-					stack[depth++]=sStkNN(p.a,p.b->childs[1]);
-					}
-					else
-					{
-					policy.Process(p.a,p.b);
-					}
-				}
-			}
-		} while(depth);
-	}
-}
-
-//
-DBVT_PREFIX
-inline void		btDbvt::collideTT(	const btDbvtNode* root0,
-									const btTransform& xform0,
-									const btDbvtNode* root1,
-									const btTransform& xform1,
-									DBVT_IPOLICY)
-{
-const btTransform	xform=xform0.inverse()*xform1;
-collideTT(root0,root1,xform,policy);
-}
-
-//
-DBVT_PREFIX
-inline void		btDbvt::collideTV(	const btDbvtNode* root,
-									const btDbvtVolume& vol,
-									DBVT_IPOLICY)
-{
-DBVT_CHECKTYPE
-if(root)
-	{
-	ATTRIBUTE_ALIGNED16(btDbvtVolume)		volume(vol);
-	btAlignedObjectArray<const btDbvtNode*>	stack;
-	stack.reserve(SIMPLE_STACKSIZE);
-	stack.push_back(root);
-	do	{
-		const btDbvtNode*	n=stack[stack.size()-1];
-		stack.pop_back();
-		if(Intersect(n->volume,volume))
-			{
-			if(n->isinternal())
-				{
-				stack.push_back(n->childs[0]);
-				stack.push_back(n->childs[1]);
-				}
-				else
-				{
-				policy.Process(n);
-				}
-			}
-		} while(stack.size()>0);
-	}
-}
-
-//
-DBVT_PREFIX
-inline void		btDbvt::collideRAY(	const btDbvtNode* root,
-									const btVector3& origin,
-									const btVector3& direction,
-									DBVT_IPOLICY)
-{
-DBVT_CHECKTYPE
-if(root)
-	{
-	const btVector3	normal=direction.normalized();
-	const btVector3	invdir(	1/normal.x(),
-							1/normal.y(),
-							1/normal.z());
-	const unsigned	signs[]={	direction.x()<0,
-								direction.y()<0,
-								direction.z()<0};
-	btAlignedObjectArray<const btDbvtNode*>	stack;
-	stack.reserve(SIMPLE_STACKSIZE);
-	stack.push_back(root);
-	do	{
-		const btDbvtNode*	node=stack[stack.size()-1];
-		stack.pop_back();
-		if(Intersect(node->volume,origin,invdir,signs))
-			{
-			if(node->isinternal())
-				{
-				stack.push_back(node->childs[0]);
-				stack.push_back(node->childs[1]);
-				}
-				else
-				{
-				policy.Process(node);
-				}
-			}
-		} while(stack.size());
-	}
+						policy.Process(node);
+					}
+				}
+			} while(depth);
+
+		}
 }
 
@@ -923,49 +1079,49 @@
 									DBVT_IPOLICY)
 {
-DBVT_CHECKTYPE
-if(root)
-	{
-	const int						inside=(1<<count)-1;
-	btAlignedObjectArray<sStkNP>	stack;
-	int								signs[sizeof(unsigned)*8];
-	btAssert(count<int (sizeof(signs)/sizeof(signs[0])));
-	for(int i=0;i<count;++i)
+	DBVT_CHECKTYPE
+		if(root)
 		{
-		signs[i]=	((normals[i].x()>=0)?1:0)+
+			const int						inside=(1<<count)-1;
+			btAlignedObjectArray<sStkNP>	stack;
+			int								signs[sizeof(unsigned)*8];
+			btAssert(count<int (sizeof(signs)/sizeof(signs[0])));
+			for(int i=0;i<count;++i)
+			{
+				signs[i]=	((normals[i].x()>=0)?1:0)+
 					((normals[i].y()>=0)?2:0)+
 					((normals[i].z()>=0)?4:0);
+			}
+			stack.reserve(SIMPLE_STACKSIZE);
+			stack.push_back(sStkNP(root,0));
+			do	{
+				sStkNP	se=stack[stack.size()-1];
+				bool	out=false;
+				stack.pop_back();
+				for(int i=0,j=1;(!out)&&(i<count);++i,j<<=1)
+				{
+					if(0==(se.mask&j))
+					{
+						const int	side=se.node->volume.Classify(normals[i],offsets[i],signs[i]);
+						switch(side)
+						{
+						case	-1:	out=true;break;
+						case	+1:	se.mask|=j;break;
+						}
+					}
+				}
+				if(!out)
+				{
+					if((se.mask!=inside)&&(se.node->isinternal()))
+					{
+						stack.push_back(sStkNP(se.node->childs[0],se.mask));
+						stack.push_back(sStkNP(se.node->childs[1],se.mask));
+					}
+					else
+					{
+						if(policy.AllLeaves(se.node)) enumLeaves(se.node,policy);
+					}
+				}
+			} while(stack.size());
 		}
-	stack.reserve(SIMPLE_STACKSIZE);
-	stack.push_back(sStkNP(root,0));
-	do	{
-		sStkNP	se=stack[stack.size()-1];
-		bool	out=false;
-		stack.pop_back();
-		for(int i=0,j=1;(!out)&&(i<count);++i,j<<=1)
-			{
-			if(0==(se.mask&j))
-				{
-				const int	side=se.node->volume.Classify(normals[i],offsets[i],signs[i]);
-				switch(side)
-					{
-					case	-1:	out=true;break;
-					case	+1:	se.mask|=j;break;
-					}
-				}
-			}
-		if(!out)
-			{
-			if((se.mask!=inside)&&(se.node->isinternal()))
-				{
-				stack.push_back(sStkNP(se.node->childs[0],se.mask));
-				stack.push_back(sStkNP(se.node->childs[1],se.mask));
-				}
-				else
-				{
-				if(policy.AllLeaves(se.node)) enumLeaves(se.node,policy);
-				}
-			}
-		} while(stack.size());
-	}
 }
 
@@ -973,97 +1129,97 @@
 DBVT_PREFIX
 inline void		btDbvt::collideOCL(	const btDbvtNode* root,
-									const btVector3* normals,
-									const btScalar* offsets,
-									const btVector3& sortaxis,
-									int count,
-									DBVT_IPOLICY,
-									bool fsort)
-{
-DBVT_CHECKTYPE
-if(root)
-	{
-	const unsigned					srtsgns=(sortaxis[0]>=0?1:0)+
-											(sortaxis[1]>=0?2:0)+
-											(sortaxis[2]>=0?4:0);
-	const int						inside=(1<<count)-1;
-	btAlignedObjectArray<sStkNPS>	stock;
-	btAlignedObjectArray<int>		ifree;
-	btAlignedObjectArray<int>		stack;
-	int								signs[sizeof(unsigned)*8];
-	btAssert(count<int (sizeof(signs)/sizeof(signs[0])));
-	for(int i=0;i<count;++i)
+								   const btVector3* normals,
+								   const btScalar* offsets,
+								   const btVector3& sortaxis,
+								   int count,
+								   DBVT_IPOLICY,
+								   bool fsort)
+{
+	DBVT_CHECKTYPE
+		if(root)
 		{
-		signs[i]=	((normals[i].x()>=0)?1:0)+
+			const unsigned					srtsgns=(sortaxis[0]>=0?1:0)+
+				(sortaxis[1]>=0?2:0)+
+				(sortaxis[2]>=0?4:0);
+			const int						inside=(1<<count)-1;
+			btAlignedObjectArray<sStkNPS>	stock;
+			btAlignedObjectArray<int>		ifree;
+			btAlignedObjectArray<int>		stack;
+			int								signs[sizeof(unsigned)*8];
+			btAssert(count<int (sizeof(signs)/sizeof(signs[0])));
+			for(int i=0;i<count;++i)
+			{
+				signs[i]=	((normals[i].x()>=0)?1:0)+
 					((normals[i].y()>=0)?2:0)+
 					((normals[i].z()>=0)?4:0);
+			}
+			stock.reserve(SIMPLE_STACKSIZE);
+			stack.reserve(SIMPLE_STACKSIZE);
+			ifree.reserve(SIMPLE_STACKSIZE);
+			stack.push_back(allocate(ifree,stock,sStkNPS(root,0,root->volume.ProjectMinimum(sortaxis,srtsgns))));
+			do	{
+				const int	id=stack[stack.size()-1];
+				sStkNPS		se=stock[id];
+				stack.pop_back();ifree.push_back(id);
+				if(se.mask!=inside)
+				{
+					bool	out=false;
+					for(int i=0,j=1;(!out)&&(i<count);++i,j<<=1)
+					{
+						if(0==(se.mask&j))
+						{
+							const int	side=se.node->volume.Classify(normals[i],offsets[i],signs[i]);
+							switch(side)
+							{
+							case	-1:	out=true;break;
+							case	+1:	se.mask|=j;break;
+							}
+						}
+					}
+					if(out) continue;
+				}
+				if(policy.Descent(se.node))
+				{
+					if(se.node->isinternal())
+					{
+						const btDbvtNode* pns[]={	se.node->childs[0],se.node->childs[1]};
+						sStkNPS		nes[]={	sStkNPS(pns[0],se.mask,pns[0]->volume.ProjectMinimum(sortaxis,srtsgns)),
+							sStkNPS(pns[1],se.mask,pns[1]->volume.ProjectMinimum(sortaxis,srtsgns))};
+						const int	q=nes[0].value<nes[1].value?1:0;				
+						int			j=stack.size();
+						if(fsort&&(j>0))
+						{
+							/* Insert 0	*/ 
+							j=nearest(&stack[0],&stock[0],nes[q].value,0,stack.size());
+							stack.push_back(0);
+#if DBVT_USE_MEMMOVE
+							memmove(&stack[j+1],&stack[j],sizeof(int)*(stack.size()-j-1));
+#else
+							for(int k=stack.size()-1;k>j;--k) stack[k]=stack[k-1];
+#endif
+							stack[j]=allocate(ifree,stock,nes[q]);
+							/* Insert 1	*/ 
+							j=nearest(&stack[0],&stock[0],nes[1-q].value,j,stack.size());
+							stack.push_back(0);
+#if DBVT_USE_MEMMOVE
+							memmove(&stack[j+1],&stack[j],sizeof(int)*(stack.size()-j-1));
+#else
+							for(int k=stack.size()-1;k>j;--k) stack[k]=stack[k-1];
+#endif
+							stack[j]=allocate(ifree,stock,nes[1-q]);
+						}
+						else
+						{
+							stack.push_back(allocate(ifree,stock,nes[q]));
+							stack.push_back(allocate(ifree,stock,nes[1-q]));
+						}
+					}
+					else
+					{
+						policy.Process(se.node,se.value);
+					}
+				}
+			} while(stack.size());
 		}
-	stock.reserve(SIMPLE_STACKSIZE);
-	stack.reserve(SIMPLE_STACKSIZE);
-	ifree.reserve(SIMPLE_STACKSIZE);
-	stack.push_back(allocate(ifree,stock,sStkNPS(root,0,root->volume.ProjectMinimum(sortaxis,srtsgns))));
-	do	{
-		const int	id=stack[stack.size()-1];
-		sStkNPS		se=stock[id];
-		stack.pop_back();ifree.push_back(id);
-		if(se.mask!=inside)
-			{
-			bool	out=false;
-			for(int i=0,j=1;(!out)&&(i<count);++i,j<<=1)
-				{
-				if(0==(se.mask&j))
-					{
-					const int	side=se.node->volume.Classify(normals[i],offsets[i],signs[i]);
-					switch(side)
-						{
-						case	-1:	out=true;break;
-						case	+1:	se.mask|=j;break;
-						}
-					}
-				}
-			if(out) continue;
-			}
-		if(policy.Descent(se.node))
-			{
-			if(se.node->isinternal())
-				{
-				const btDbvtNode* pns[]={	se.node->childs[0],se.node->childs[1]};
-				sStkNPS		nes[]={	sStkNPS(pns[0],se.mask,pns[0]->volume.ProjectMinimum(sortaxis,srtsgns)),
-									sStkNPS(pns[1],se.mask,pns[1]->volume.ProjectMinimum(sortaxis,srtsgns))};
-				const int	q=nes[0].value<nes[1].value?1:0;				
-				int			j=stack.size();
-				if(fsort&&(j>0))
-					{
-					/* Insert 0	*/ 
-					j=nearest(&stack[0],&stock[0],nes[q].value,0,stack.size());
-					stack.push_back(0);
-					#if DBVT_USE_MEMMOVE
-					memmove(&stack[j+1],&stack[j],sizeof(int)*(stack.size()-j-1));
-					#else
-					for(int k=stack.size()-1;k>j;--k) stack[k]=stack[k-1];
-					#endif
-					stack[j]=allocate(ifree,stock,nes[q]);
-					/* Insert 1	*/ 
-					j=nearest(&stack[0],&stock[0],nes[1-q].value,j,stack.size());
-					stack.push_back(0);
-					#if DBVT_USE_MEMMOVE
-					memmove(&stack[j+1],&stack[j],sizeof(int)*(stack.size()-j-1));
-					#else
-					for(int k=stack.size()-1;k>j;--k) stack[k]=stack[k-1];
-					#endif
-					stack[j]=allocate(ifree,stock,nes[1-q]);
-					}
-					else
-					{
-					stack.push_back(allocate(ifree,stock,nes[q]));
-					stack.push_back(allocate(ifree,stock,nes[1-q]));
-					}
-				}
-				else
-				{
-				policy.Process(se.node,se.value);
-				}
-			}
-		} while(stack.size());
-	}
 }
 
@@ -1071,24 +1227,24 @@
 DBVT_PREFIX
 inline void		btDbvt::collideTU(	const btDbvtNode* root,
-									DBVT_IPOLICY)
-{
-DBVT_CHECKTYPE
-if(root)
-	{
-	btAlignedObjectArray<const btDbvtNode*>	stack;
-	stack.reserve(SIMPLE_STACKSIZE);
-	stack.push_back(root);
-	do	{
-		const btDbvtNode*	n=stack[stack.size()-1];
-		stack.pop_back();
-		if(policy.Descent(n))
-			{
-			if(n->isinternal())
-				{ stack.push_back(n->childs[0]);stack.push_back(n->childs[1]); }
-				else
-				{ policy.Process(n); }
-			}
-		} while(stack.size()>0);
-	}
+								  DBVT_IPOLICY)
+{
+	DBVT_CHECKTYPE
+		if(root)
+		{
+			btAlignedObjectArray<const btDbvtNode*>	stack;
+			stack.reserve(SIMPLE_STACKSIZE);
+			stack.push_back(root);
+			do	{
+				const btDbvtNode*	n=stack[stack.size()-1];
+				stack.pop_back();
+				if(policy.Descent(n))
+				{
+					if(n->isinternal())
+					{ stack.push_back(n->childs[0]);stack.push_back(n->childs[1]); }
+					else
+					{ policy.Process(n); }
+				}
+			} while(stack.size()>0);
+		}
 }
 
